Index: django/db/models/query.py
===================================================================
--- django/db/models/query.py	(revision 13018)
+++ django/db/models/query.py	(working copy)
@@ -337,8 +337,11 @@
         if num == 1:
             return clone._result_cache[0]
         if not num:
-            raise self.model.DoesNotExist("%s matching query does not exist."
-                    % self.model._meta.object_name)
+            raise self.model.DoesNotExist(
+                "%s matching query does not exist.  "
+                "get() parameters were %s"
+                % (self.model._meta.object_name, kwargs)
+            )
         raise self.model.MultipleObjectsReturned("get() returned more than one %s -- it returned %s! Lookup parameters were %s"
                 % (self.model._meta.object_name, num, kwargs))
 
Index: django/contrib/sites/tests.py
===================================================================
--- django/contrib/sites/tests.py	(revision 13018)
+++ django/contrib/sites/tests.py	(working copy)
@@ -12,7 +12,7 @@
 >>> Site.objects.get_current()
 Traceback (most recent call last):
 ...
-DoesNotExist: Site matching query does not exist.
+DoesNotExist: Site matching query does not exist.  get() parameters were {'pk': 1}
 
 # After updating a Site object (e.g. via the admin), we shouldn't return a
 # bogus value from the SITE_CACHE.
Index: tests/modeltests/custom_pk/models.py
===================================================================
--- tests/modeltests/custom_pk/models.py	(revision 13018)
+++ tests/modeltests/custom_pk/models.py	(working copy)
@@ -58,7 +58,7 @@
 >>> Employee.objects.get(pk=42)
 Traceback (most recent call last):
     ...
-DoesNotExist: Employee matching query does not exist.
+DoesNotExist: Employee matching query does not exist.  get() parameters were {'pk': 42}
 
 # Use the name of the primary key, rather than pk.
 >>> Employee.objects.get(employee_code__exact=123)
Index: tests/modeltests/model_inheritance/models.py
===================================================================
--- tests/modeltests/model_inheritance/models.py	(revision 13018)
+++ tests/modeltests/model_inheritance/models.py	(working copy)
@@ -294,7 +294,7 @@
 >>> place.restaurant.italianrestaurant
 Traceback (most recent call last):
     ...
-DoesNotExist: ItalianRestaurant matching query does not exist.
+DoesNotExist: ItalianRestaurant matching query does not exist.  get() parameters were {'restaurant_ptr__pk': 3}
 
 # An ItalianRestaurant which does not exist is also a Place which does not exist.
 >>> try:
@@ -323,7 +323,7 @@
 >>> p.restaurant
 Traceback (most recent call last):
     ...
-DoesNotExist: Restaurant matching query does not exist.
+DoesNotExist: Restaurant matching query does not exist.  get() parameters were {'place_ptr__pk': 5}
 
 # But we can descend from p to the Supplier child, as expected.
 >>> p.supplier
Index: tests/modeltests/basic/models.py
===================================================================
--- tests/modeltests/basic/models.py	(revision 13018)
+++ tests/modeltests/basic/models.py	(working copy)
@@ -100,17 +100,17 @@
 >>> Article.objects.get(id__exact=2)
 Traceback (most recent call last):
     ...
-DoesNotExist: Article matching query does not exist.
+DoesNotExist: Article matching query does not exist.  get() parameters were {'id__exact': 2}
 
 >>> Article.objects.get(pub_date__year=2005, pub_date__month=8)
 Traceback (most recent call last):
     ...
-DoesNotExist: Article matching query does not exist.
+DoesNotExist: Article matching query does not exist.  get() parameters were {'pub_date__year': 2005, 'pub_date__month': 8}
 
 >>> Article.objects.get(pub_date__week_day=6)
 Traceback (most recent call last):
     ...
-DoesNotExist: Article matching query does not exist.
+DoesNotExist: Article matching query does not exist.  get() parameters were {'pub_date__week_day': 6}
 
 # Lookup by a primary key is the most common case, so Django provides a
 # shortcut for primary-key exact lookups.
Index: tests/modeltests/one_to_one/models.py
===================================================================
--- tests/modeltests/one_to_one/models.py	(revision 13018)
+++ tests/modeltests/one_to_one/models.py	(working copy)
@@ -69,7 +69,7 @@
 >>> p2.restaurant
 Traceback (most recent call last):
     ...
-DoesNotExist: Restaurant matching query does not exist.
+DoesNotExist: Restaurant matching query does not exist.  get() parameters were {'place__pk': 2}
 
 # Set the place using assignment notation. Because place is the primary key on
 # Restaurant, the save will create a new restaurant
Index: tests/modeltests/get_latest/models.py
===================================================================
--- tests/modeltests/get_latest/models.py	(revision 13018)
+++ tests/modeltests/get_latest/models.py	(working copy)
@@ -34,7 +34,7 @@
 >>> Article.objects.latest()
 Traceback (most recent call last):
     ...
-DoesNotExist: Article matching query does not exist.
+DoesNotExist: Article matching query does not exist.  get() parameters were {}
 
 # Create a couple of Articles.
 >>> from datetime import datetime
Index: tests/regressiontests/model_inheritance_regress/models.py
===================================================================
--- tests/regressiontests/model_inheritance_regress/models.py	(revision 13018)
+++ tests/regressiontests/model_inheritance_regress/models.py	(working copy)
@@ -243,12 +243,12 @@
 >>> Place.objects.get(pk=ident)
 Traceback (most recent call last):
 ...
-DoesNotExist: Place matching query does not exist.
+DoesNotExist: Place matching query does not exist.  get() parameters were {'pk': 1}
 
 >>> ItalianRestaurant.objects.get(pk=ident)
 Traceback (most recent call last):
 ...
-DoesNotExist: ItalianRestaurant matching query does not exist.
+DoesNotExist: ItalianRestaurant matching query does not exist.  get() parameters were {'pk': 1}
 
 # Regression test for #6755
 >>> r = Restaurant(serves_pizza=False)
Index: tests/regressiontests/reverse_single_related/models.py
===================================================================
--- tests/regressiontests/reverse_single_related/models.py	(revision 13018)
+++ tests/regressiontests/reverse_single_related/models.py	(working copy)
@@ -49,6 +49,6 @@
 >>> private_item.source
 Traceback (most recent call last):
     ...
-DoesNotExist: Source matching query does not exist.
+DoesNotExist: Source matching query does not exist.  get() parameters were {'id__exact': 2}
 
 """}