diff --git a/docs/internals/contributing.txt b/docs/internals/contributing.txt
--- a/docs/internals/contributing.txt
+++ b/docs/internals/contributing.txt
@@ -393,8 +393,8 @@
 Various parts of Django, such as the admin site and validation error messages,
 are internationalized. This means they display different text depending on a
 user's language setting. For this, Django uses the same internationalization
-infrastructure that is available to Django applications that is described
-in the :ref:`i18n documentation<topics-i18n>`.
+infrastructure available to Django applications described in the
+:ref:`i18n documentation<topics-i18n>`.
 
 These translations are contributed by Django users worldwide. If you find an
 incorrect translation, or if you'd like to add a language that isn't yet
diff --git a/docs/ref/contrib/syndication.txt b/docs/ref/contrib/syndication.txt
--- a/docs/ref/contrib/syndication.txt
+++ b/docs/ref/contrib/syndication.txt
@@ -271,7 +271,7 @@
 
 Feeds created by the syndication framework automatically include the
 appropriate ``<language>`` tag (RSS 2.0) or ``xml:lang`` attribute (Atom). This
-comes directly from your :setting:`LANGUAGE_CODE setting`.
+comes directly from your :setting:`LANGUAGE_CODE` setting.
 
 URLs
 ----
diff --git a/docs/ref/settings.txt b/docs/ref/settings.txt
--- a/docs/ref/settings.txt
+++ b/docs/ref/settings.txt
@@ -411,7 +411,7 @@
 Default: ``'N j, Y'`` (e.g. ``Feb. 4, 2003``)
 
 The default formatting to use for displaying date fields in any part of the
-system. Note that if setting:`USE_L10N` is set to ``True``, then the
+system. Note that if :setting:`USE_L10N` is set to ``True``, then the
 locale-dictated format has higher precedence and will be applied instead. See
 :ttag:`allowed date format strings <now>`.
 
@@ -451,7 +451,7 @@
 Default: ``'N j, Y, P'`` (e.g. ``Feb. 4, 2003, 4 p.m.``)
 
 The default formatting to use for displaying datetime fields in any part of the
-system. Note that if setting:`USE_L10N` is set to ``True``, then the
+system. Note that if :setting:`USE_L10N` is set to ``True``, then the
 locale-dictated format has higher precedence and will be applied instead. See
 :ttag:`allowed date format strings <now>`.
 
@@ -1341,9 +1341,9 @@
 Default: ``m/d/Y`` (e.g. ``12/31/2003``)
 
 An available formatting that can be used for displaying date fields on
-templates. Note that if ``USE_L10N`` is set to ``True``, then the corresponding
-locale-dictated format has higher precedence and will be applied. See
-:ttag:`allowed date format strings <now>`.
+templates. Note that if :setting:`USE_L10N` is set to ``True``, then the
+corresponding locale-dictated format has higher precedence and will be applied.
+See :ttag:`allowed date format strings <now>`.
 
 See also ``DATE_FORMAT`` and ``SHORT_DATETIME_FORMAT``.
 
@@ -1357,9 +1357,9 @@
 Default: ``m/d/Y P`` (e.g. ``12/31/2003 4 p.m.``)
 
 An available formatting that can be used for displaying datetime fields on
-templates. Note that if ``USE_L10N`` is set to ``True``, then the corresponding
-locale-dictated format has higher precedence and will be applied. See
-:ttag:`allowed date format strings <now>`.
+templates. Note that if :setting:`USE_L10N` is set to ``True``, then the
+corresponding locale-dictated format has higher precedence and will be applied.
+See :ttag:`allowed date format strings <now>`.
 
 See also ``DATE_FORMAT`` and ``SHORT_DATETIME_FORMAT``.
 
@@ -1497,7 +1497,7 @@
 Default: ``'P'`` (e.g. ``4 p.m.``)
 
 The default formatting to use for displaying time fields in any part of the
-system. Note that if setting:`USE_L10N` is set to ``True``, then the
+system. Note that if :setting:`USE_L10N` is set to ``True``, then the
 locale-dictated format has higher precedence and will be applied instead. See
 :ttag:`allowed date format strings <now>`.
 
diff --git a/docs/topics/i18n/deployment.txt b/docs/topics/i18n/deployment.txt
--- a/docs/topics/i18n/deployment.txt
+++ b/docs/topics/i18n/deployment.txt
@@ -124,8 +124,6 @@
       selection to German and English (and any sublanguage, like de-ch or
       en-us).
 
-      .. _LANGUAGES setting: ../settings/#languages
-
     * If you define a custom ``LANGUAGES`` setting, as explained in the
       previous bullet, it's OK to mark the languages as translation strings
       -- but use a "dummy" ``ugettext()`` function, not the one in